%%
clc;
clear all;
close all;

%% Snifferomyces ODE run

x0=zeros(18,1);
x0(1) = 0.1548;
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;
t = linspace(0,18000,100);
[t,y] = ode23s('Snifferomyces',t,x0);
TBGFP = y(:,17);
Threshold = max(y(:,17));
plot(t,TBGFP);
%% Flase Positive Test - LigandConcentration : 0 - 0.19 [uM]

clc;close all;
a = 0;
b = 0.19;
Lp =  a + (b-a).*rand(50,1);
FpCount = 0;
clear gfp_fp;
x0=zeros(18,1);
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;

for i = 1:50
    x0(1) = Lp(i);
    t = linspace(0,18000,100);
    [t,y] = ode23s('Snifferomyces',t,x0);
    gfp_fp(:,i) = y(:,17);
    if max(y(:,17))>Threshold
        FpCount = FpCount + 1;
    end
end
%% Flase Negative Test - LigandConcentration : 0.2 - 20 [uM]
clc;close all;
a = 0.2;
b = 20;
Ln =  a + (b-a).*rand(100,1);
FnCount = 0;
clear gfp_fn;
x0=zeros(18,1);
x0(2) = 0.2;
x0(3) = 0;
x0(4) = 1.667;
x0(5) = 0.0;
x0(6) = 0.686;
x0(7) = 0.0;
x0(8) = 1.667;
x0(9) = 0.0;
x0(10) = 0.0;
x0(11) = 0.0;
x0(12) = 0.505;
x0(13) = 0.0;
x0(14) = 0.0;
x0(15) = 0.036;
x0(16) = 0;
x0(17) = 0;
x0(18) = 0;

for i = 1:50
    x0(1) = Ln(i);
    t = linspace(0,18000,100);
    [t,y] = ode23s('Snifferomyces',t,x0);
    gfp_fn(:,i) = y(:,17);
    if max(y(:,17))<Threshold
        FnCount = FnCount + 1;
    end
end
% Plotting the results
plot(t,TBGFP,'k--','LineWidth',3);hold on;legend('Threshold')
plot(t,gfp_fp);plot(t,gfp_fn);hold off;
