function xdot=Snifferomyces(~,x)
global  Kmrnas Kmrnadg Kngfps Kmgfps Kmgfpdg;

reaction_reaction_18_k = 8.376523998593117e-08;%Kmrnas
reaction_reaction_19_k1 = 2.155839679306574;%Kmrnadg
reaction_reaction_20_k = 2.717203164733281e+03;%Kngfps
reaction_reaction_21_k1 = 2.724573018572289e-04;%Kmgfps
reaction_reaction_22_kmgfpdg =3.052810074235267e-04;%Kmgfpdg


% Compartment: id = compartment_1, name = Extracellular, constant
	compartment_compartment_1=1.0;
% Compartment: id = compartment_2, name = Cell, constant
	compartment_compartment_2=1.0;
% Reaction: id = reaction_1, name = Receptor Activation

	% Local Parameter:   id =  kSte2a, name = kSte2a
	reaction_reaction_1_kSte2a=0.071;

	reaction_reaction_1=compartment_compartment_2*function_function_1(x(1), reaction_reaction_1_kSte2a, x(4));
% Reaction: id = reaction_2, name = Receptor Inactivation

	% Local Parameter:   id =  kSte2ia, name = kSte2ia
	reaction_reaction_2_kSte2ia=2.457;

	reaction_reaction_2=compartment_compartment_2*function_function_2(x(14), reaction_reaction_2_kSte2ia);
% Reaction: id = reaction_4, name = Receptor-Ligand Degradation

	% Local Parameter:   id =  kSte2adg, name = kSte2adg
	reaction_reaction_4_kSte2adg=1.199;

	reaction_reaction_4=compartment_compartment_2*function_function_4(x(14), reaction_reaction_4_kSte2adg);
% Reaction: id = reaction_5, name = G-Protein Activation

	% Local Parameter:   id =  kgpa, name = kgpa
	reaction_reaction_5_kgpa=0.724;

	reaction_reaction_5=compartment_compartment_2*function_function_5(x(8), x(14), reaction_reaction_5_kgpa);
% Reaction: id = reaction_6, name = G-Protein Inactivation

	% Local Parameter:   id =  kgpia, name = kgpia
	reaction_reaction_6_kgpia=1.259;

	reaction_reaction_6=compartment_compartment_2*function_function_7(x(10), reaction_reaction_6_kgpia);
% Reaction: id = reaction_7, name = G-Protein Inactivation Under phosphorylated Sst2

	% Local Parameter:   id =  kgpiasst2, name = kgpiasst2
	reaction_reaction_7_kgpiasst2=1.124;

	reaction_reaction_7=compartment_compartment_2*function_function_8(x(10), x(13), reaction_reaction_7_kgpiasst2);
% Reaction: id = reaction_8, name = Heterotrimeric G-Protein Formation

	% Local Parameter:   id =  Kgpformation, name = Kgpformation
	reaction_reaction_8_Kgpformation=0.0020;

	reaction_reaction_8=compartment_compartment_2*function_function_9(x(11), x(9), reaction_reaction_8_Kgpformation);
% Reaction: id = reaction_9, name = complex D synthesis

	% Local Parameter:   id =  kDsyn, name = kDsyn
	reaction_reaction_9_kDsyn=0.021;

	reaction_reaction_9=compartment_compartment_2*function_function_10(x(15), x(11), reaction_reaction_9_kDsyn);
% Reaction: id = reaction_10, name = complex D degradation

	% Local Parameter:   id =  kDdg, name = kDdg
	reaction_reaction_10_kDdg=0.0040;

	reaction_reaction_10=compartment_compartment_2*function_function_11(x(5), reaction_reaction_10_kDdg);
% Reaction: id = reaction_11, name = complex D degradation under phosphorylated Sst2

	% Local Parameter:   id =  kDdgsst2a, name = kDdgsst2a
	reaction_reaction_11_kDdgsst2a=0.261;

	reaction_reaction_11=compartment_compartment_2*function_function_12(x(5), x(13), reaction_reaction_11_kDdgsst2a);
% Reaction: id = reaction_12, name = Fus3 Activation

	% Local Parameter:   id =  kfus3a, name = kfus3a
	reaction_reaction_12_kfus3a=0.818;

	reaction_reaction_12=compartment_compartment_2*function_function_13(x(6), reaction_reaction_12_kfus3a, x(5));
% Reaction: id = reaction_13, name = Fus3 Inactivation

	% Local Parameter:   id =  kfus3ia, name = kfus3ia
	reaction_reaction_13_kfus3ia=0.0;

	reaction_reaction_13=compartment_compartment_2*function_function_14(x(7), reaction_reaction_13_kfus3ia);
% Reaction: id = reaction_14, name = Fus3 Inactivation by Sst2

	% Local Parameter:   id =  kfus3iasst2, name = kfus3iasst2
	reaction_reaction_14_kfus3iasst2=0.017;

	reaction_reaction_14=compartment_compartment_2*function_function_15(x(7), reaction_reaction_14_kfus3iasst2);
% Reaction: id = reaction_15, name = Activation of Sst2

	% Local Parameter:   id =  ksst2a, name = ksst2a
	reaction_reaction_15_ksst2a=0.342;

	reaction_reaction_15=compartment_compartment_2*function_function_16(x(12), x(6), reaction_reaction_15_ksst2a);
% Reaction: id = reaction_16, name = Inactivation of Sst2

	% Local Parameter:   id =  ksst2ia, name = ksst2ia
	reaction_reaction_16_ksst2ia=0.643;

	reaction_reaction_16=compartment_compartment_2*function_function_17(x(13), reaction_reaction_16_ksst2ia);
% Reaction: id = reaction_3, name = Activation of Ste12

	% Local Parameter:   id =  kste12a, name = kste12a
	reaction_reaction_3_kste12a=300;

	reaction_reaction_3=compartment_compartment_1*function_function_3(x(2), x(7), reaction_reaction_3_kste12a);
% Reaction: id = reaction_17, name = Inactivation of Ste12

	% Local Parameter:   id =  kste12ia, name = kste12ia
	reaction_reaction_17_kste12ia=20;

	reaction_reaction_17=compartment_compartment_1*function_function_6(x(3), reaction_reaction_17_kste12ia);
% Reaction: id = reaction_18, name = GFP-mRNA Synthesis

	% Local Parameter:   id =  k, name = k
% 	reaction_reaction_18_k=4.0E-6;

	reaction_reaction_18=compartment_compartment_2*function_function_18(x(3), reaction_reaction_18_k);
% Reaction: id = reaction_19, name = GFP-mRNA Degradation

	% Local Parameter:   id =  k1, name = k1
% 	reaction_reaction_19_k1=0.00214;

	reaction_reaction_19=compartment_compartment_2*reaction_reaction_19_k1*x(16);
% Reaction: id = reaction_20, name = Nascent GFP Synthesis

	% Local Parameter:   id =  k, name = k
% 	reaction_reaction_20_k=2.0;

	reaction_reaction_20=compartment_compartment_2*function_function_18(x(16), reaction_reaction_20_k);
% Reaction: id = reaction_21, name = Mature GFP Synthesis

	% Local Parameter:   id =  k1, name = k1
% 	reaction_reaction_21_k1=9.625E-5;

	reaction_reaction_21=compartment_compartment_2*reaction_reaction_21_k1*x(18);
% Reaction: id = reaction_22, name = Mature GFP degradation

	% Local Parameter:   id =  kmgfpdg, name = kmgfpdg
% 	reaction_reaction_22_kmgfpdg=9.7E-6;

	reaction_reaction_22=compartment_compartment_2*function_function_19(x(17), reaction_reaction_22_kmgfpdg);
	xdot=zeros(18,1);
	% Species:   id = species_3, name = L
% Warning species is not changed by either rules or reactions
   
    Kldg = 0.03; 
	xdot(1) = -1.0 * Kldg*x(1);

	% Species:   id = species_14, name = Ste12, affected by kineticLaw

	xdot(2) = (1/(compartment_compartment_1))*((-1.0 * reaction_reaction_3) + ( 1.0 * reaction_reaction_17));

	% Species:   id = species_15, name = Ste12a, affected by kineticLaw

	xdot(3) = (1/(compartment_compartment_1))*(( 1.0 * reaction_reaction_3) + (-1.0 * reaction_reaction_17));

	% Species:   id = species_1, name = Ste2, affected by kineticLaw

	xdot(4) = (1/(compartment_compartment_2))*((-1.0 * reaction_reaction_1) + ( 1.0 * reaction_reaction_2));

	% Species:   id = species_10, name = D, affected by kineticLaw

	xdot(5) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_9) + (-1.0 * reaction_reaction_10) + (-1.0 * reaction_reaction_11));

	% Species:   id = species_11, name = Fus3, affected by kineticLaw

	xdot(6) = (1/(compartment_compartment_2))*((-1.0 * reaction_reaction_12) + ( 1.0 * reaction_reaction_13) + ( 1.0 * reaction_reaction_14));

	% Species:   id = species_12, name = Fus3a, affected by kineticLaw

	xdot(7) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_12) + (-1.0 * reaction_reaction_13) + (-1.0 * reaction_reaction_14));

	% Species:   id = species_5, name = Gabc, affected by kineticLaw

	xdot(8) = (1/(compartment_compartment_2))*((-1.0 * reaction_reaction_5) + ( 1.0 * reaction_reaction_8));

	% Species:   id = species_7, name = GaGDP, affected by kineticLaw

	xdot(9) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_6) + ( 1.0 * reaction_reaction_7) + (-1.0 * reaction_reaction_8));

	% Species:   id = species_4, name = GaGTP, affected by kineticLaw

	xdot(10) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_5) + (-1.0 * reaction_reaction_6) + (-1.0 * reaction_reaction_7));

	% Species:   id = species_6, name = Gbc, affected by kineticLaw

	xdot(11) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_5) + (-1.0 * reaction_reaction_8) + (-1.0 * reaction_reaction_9) + ( 1.0 * reaction_reaction_10) + ( 1.0 * reaction_reaction_11));

	% Species:   id = species_8, name = Sst2, affected by kineticLaw

	xdot(12) = (1/(compartment_compartment_2))*((-1.0 * reaction_reaction_15) + ( 1.0 * reaction_reaction_16));

	% Species:   id = species_13, name = Sst2a, affected by kineticLaw

	xdot(13) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_15) + (-1.0 * reaction_reaction_16));

	% Species:   id = species_2, name = Ste2a, affected by kineticLaw

	xdot(14) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_1) + (-1.0 * reaction_reaction_2) + (-1.0 * reaction_reaction_4));

	% Species:   id = species_9, name = C, affected by kineticLaw

	xdot(15) = (1/(compartment_compartment_2))*((-1.0 * reaction_reaction_9) + ( 1.0 * reaction_reaction_10) + ( 1.0 * reaction_reaction_11));

	% Species:   id = species_16, name = GFP-mRNA, affected by kineticLaw

	xdot(16) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_18) + (-1.0 * reaction_reaction_19));

	% Species:   id = species_17, name = mature-GFP, affected by kineticLaw

	xdot(17) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_21) + (-1.0 * reaction_reaction_22));


	% Species:   id = species_18, name = nascent-GFP, affected by kineticLaw

	xdot(18) = (1/(compartment_compartment_2))*(( 1.0 * reaction_reaction_20) + (-1.0 * reaction_reaction_21));

end



function z=function_function_1(L,kSte2a,Ste2), z=(Ste2*L*kSte2a);end

function z=function_function_2(Ste2a,kSte2ia), z=(Ste2a*kSte2ia);end

function z=function_function_4(Ste2a,kSte2adg), z=(Ste2a*kSte2adg);end

function z=function_function_5(Gabc,Ste2a,kgpa), z=(Gabc*Ste2a*kgpa);end

function z=function_function_7(GaGTP,kgpia), z=(GaGTP*kgpia);end

function z=function_function_8(GaGTP,Sst2a,kgpiasst2), z=(GaGTP*Sst2a*kgpiasst2);end

function z=function_function_9(GaGDP,Gbc,Kgpformation), z=(GaGDP*Gbc*Kgpformation);end

function z=function_function_10(C,Gbc,kDsyn), z=(C*Gbc*kDsyn);end

function z=function_function_11(D,kDdg), z=(D*kDdg);end

function z=function_function_12(D,Sst2a,kDdgsst2a), z=(D*Sst2a*kDdgsst2a);end

function z=function_function_13(Fus3,kfus3a,D), z=(Fus3*D*kfus3a);end

function z=function_function_14(Fus3a,kfus3ia), z=(Fus3a*kfus3ia);end

function z=function_function_15(Fus3a,kfus3iasst2), z=(Fus3a*kfus3iasst2);end

function z=function_function_16(Sst2,Fus3,ksst2a), z=(Sst2*Fus3*ksst2a);end

function z=function_function_17(Sst2a,ksst2ia), z=(Sst2a*ksst2ia);end

function z=function_function_19(GFP,kmgfpdg), z=(GFP*kmgfpdg);end

function z=function_function_3(Ste12,Fus3a,kste12a), z=(Ste12*Fus3a*kste12a);end

function z=function_function_6(Ste12a,kste12ia), z=(Ste12a*kste12ia);end

function z=function_function_18(Activator,k), z=(k*Activator);end
